#!/usr/bin/env python3




def get_topidp(data):
    score=0.
    for aa in aas_sorted_topidp:
        score+=top_idp[aa]*data["freq_"+aa]
    return score

def get_topidp_noser(data):
    score=0.
    for aa in aas_sorted_topidp:
        score+=top_idp_noser[aa]*data["freq_"+aa]
    return score

def get_topidp_noserpro(data):
    score=0.
    for aa in aas_sorted_topidp:
        score+=top_idp_noserpro[aa]*data["freq_"+aa]
    return score

def get_topidp_noserlyspro(data):
    score=0.
    for aa in aas_sorted_topidp:
        score+=top_idp_noserlyspro[aa]*data["freq_"+aa]
    return score
    
# coding: utf-8
def get_aa_freq(aa,gc):
    codons = aa2codons[aa]
    prob_tot = []
    for codon in codons:
        prob_codon = []
        for N in codon:
            prob = gc/2
            if N in {"A","T","U"}:
                prob = 0.5-(gc/2)
            prob_codon += [prob]
        #print(codon, prob_codon,functools.reduce(mul,prob_codon))
        prob_tot += [functools.reduce(mul,prob_codon)] # Use functools.reduce() if you really need it; however, 99 percent of the time an explicit for loop is more readable
    prob_tot = sum(prob_tot)
    return prob_tot


from operator import mul
import pandas as pd
import matplotlib.pyplot as plt
import matplotlib.patches as mpatches
import seaborn as sns
import functools
from scipy.stats import ttest_ind
from scipy.stats import mannwhitneyu
from scipy.spatial import distance
from scipy.stats import norm
#from numpy import sqrt, abs, round
import numpy as np
import math as math
from matplotlib import colors
from matplotlib import cm

def darken(col):
    c = colors.hex2color(col)
    nc = []
    for e in c:
        ne = e-0.4
        if ne < 0: ne = 0
        nc += [ne]
    return nc

    

def twoSampZ(X1, X2, mudiff, sd1, sd2, n1, n2):
    pooledSE = sqrt(sd1**2/n1 + sd2**2/n2)
    z = ((X1 - X2) - mudiff)/pooledSE
    pval = 2*(1 - norm.cdf(abs(z)))
    return round(z, 3), round(pval, 4)


if __name__ == "__main__":
    figures_dir="../figures_medGC/"
    dic_labels = {"GC":"GC%","GC_genomic":"GC% (genomic)", 'other':'Intermediate',
    'ancient':'Ancient','orphan':'Orphans','group_orphan':"Genus\norphans",
    'hessa':"<Hydrophobicity> (Hessa)", "top-idp":"TOP-IDP", "topidp-S":"TOP-IDP - S","topidp-SKP":"TOP-IDP - SKP","topidp-SP":"TOP-IDP - SP",
    "ss_alpha":"<Alpha propensity>","ss_beta":"<Beta propensity>","ss_coil":"<Coil propensity>", 'ss_turn':"<Turn propensity>","length_translation":"Length (AA)", 'gc_third':'GC% (third nucleotide)','taxon_gc':'GC% (taxonomic avg)','taxon_gc_r':'GC% (taxonomic avg)',
    'random':'Expected','iupred_long':'IUpred long (%AA)','length_aa':'<Length> (AA)','gc':'GC%',
    'iupred_short':'IUpred short (%AA)','iupred_cutoff':'IUpred cutoff (%AA)', 'idp':'<TOP-IDP>','tm':'TM (%AA)','transmembrane':'TM (%AA)',"volatility":"<Volatility>", 'iupred_short':'IUpred short (%AA)','iupred_cutoff':'IUpred cutoff (%AA)','seg':'<SEG>',
    'hydropathy':'<Hydrophobicity> (Kyte-Doolittle)','gc':'GC%','aa_corr':'AA freq\ncorrelation with  expected', 'aa_corr_dot':'AA freq\ncorrelation with   expected','aa_corr_r':'AA freq\ncorrelation with expected', 'A':
    'ALA', 'C': 'CYS', 'E': 'GLU', 'D': 'ASP', 'G': 'GLY', 'F': 'PHE',
    'I': 'ILE', 'H': 'HIS', 'K': 'LYS', 'M': 'MET', 'L': 'LEU', 'N':
    'ASN', 'Q': 'GLN', 'P':'PRO', 'S': 'SER', 'R': 'ARG', 'T': 'THR',
    'W': 'TRP', 'V': 'VAL', 'Y': 'TYR', 'freq_A': 'ALA', 'freq_C':
    'CYS', 'freq_E': 'GLU', 'freq_D': 'ASP', 'freq_G': 'GLY',
    'freq_F': 'PHE', 'freq_I': 'ILE', 'freq_H': 'HIS', 'freq_K':
    'LYS', 'freq_M': 'MET', 'freq_L': 'LEU', 'freq_N': 'ASN',
    'freq_Q': 'GLN', 'freq_P': 'PRO', 'freq_S': 'SER', 'freq_R':
    'ARG', 'freq_T': 'THR', 'freq_W': 'TRP', 'freq_V': 'VAL',
    'freq_Y': 'TYR', 'scampi':'TM (%AA)',
    'slider':'Slider','disembl_coils':'DisEMBL Coils (%AA)','disembl_rem465':"DisEMBL REM465 (%AA)",
    'disembl_hotloops':"DisEMBL Hotloops (%AA)", "globpipe":"GlobPlot (%AA)","length":"Length (AA)", "euk":"Eukaryota",
    "pro":"Bacteria",
    "arc":"Archaea",'Eukaryota':'Eukaryota','Bacteria':'Bacteria','Archaea':'Archaea','Viruses':'Viruses'}
        
    ylabels = {"GC":"Fraction","GC_genomic":"Fraction", 'other':'Intermediate',
    'ancient':'Ancient','orphan':'Orphans','group_orphan':"Genus\norphans",
    'hessa':"<Hydrophobicity>", "top-idp":"<TOP-IDP>","topidp-S":"<TOP-IDP-noS>","topidp-SKP":"<TOP-IDP-noSKP>","topidp-SP":"<TOP-IDP-noSP>",
    "ss_alpha":"<Alpha propensity>","ss_beta":"<Beta propensity>","ss_coil":"<Coil propensity>", 'ss_turn':"<Turn propensity>","length_translation":"Length (AA)", 'gc_third':'fraction','taxon_gc':'fraction','taxon_gc_r':'fraction',
    'random':'fraction','iupred_long':'Fraction of AA','length_aa':'<Length>','gc':'fraction',
    'iupred_short':'Fration of residues','iupred_cutoff':'Fraction of residues', 'idp':'<TOP-IDP>','tm':'Fraction of residues',"volatility":"<Volatility>", 'iupred_short':'Fraction of residues','iupred_cutoff':'Fraction of residues','seg':'<SEG>',
    'hydropathy':'<Hydrophobicity>','gc':'Fraction','aa_corr':'Correlation', 'aa_corr_dot':'correlation','aa_corr_r':'Correlation', 'A':'ALA', 'C': 'CYS', 'E': 'GLU', 'D': 'ASP', 'G': 'GLY', 'F': 'PHE',
    'I': 'ILE', 'H': 'HIS', 'K': 'LYS', 'M': 'MET', 'L': 'LEU', 'N':
    'ASN', 'Q': 'GLN', 'P': 'PRO', 'S': 'SER', 'R': 'ARG', 'T': 'THR',
    'W': 'TRP', 'V': 'VAL', 'Y': 'TYR', 'freq_A': 'Fraction of residues', 'freq_C':
    'Fraction of residues', 'freq_E': 'Fraction of residues', 'freq_D': 'Fraction of residues', 'freq_G': 'Fraction of residues',
    'freq_F': 'Fraction of residues', 'freq_I': 'Fraction of residues', 'freq_H': 'Fraction of residues', 'freq_K':
    'Fraction of residues', 'freq_M': 'Fraction of residues', 'freq_L': 'Fraction of residues', 'freq_N': 'Fraction of residues',
    'freq_Q': 'Fraction of residues', 'freq_P': 'Fraction of residues', 'freq_S': 'Fraction of residues', 'freq_R':
    'Fraction of residues', 'freq_T': 'Fraction of residues', 'freq_W': 'Fraction of residues', 'freq_V': 'Fraction of residues',
    'freq_Y': 'Fraction of residues', 'scampi':'TM (%AA)',
    'slider':'Slider','disembl_coils':'DisEMBL Coils (%AA)','disembl_rem465':"DisEMBL REM465 (%AA)",
    'disembl_hotloops':"DisEMBL Hotloops (%AA)", "globpipe":"GlobPlot (%AA)","length":"Length (AA)", "euk":"Eukaryota",
    "pro":"Bacteria",
    "arc":"Archaea",'Eukaryota':'Eukaryota','Bacteria':'Bacteria','Archaea':'Archaea'}
        
    top_idp = {'A':0.06, 'C' :  0.02, 'D' : 0.192, 'E' : 0.736,
        'F' :  -0.697, 'G' : 0.166, 'H':0.303, 'I' :  -0.486,
        'K' : 0.586, 'L' :  -0.326, 'M': -0.397, 'N' : 0.007,
        'P' : 0.987, 'Q' : 0.318, 'R' : 0.180, 'S':  0.341,
        'T' : 0.059, 'V' :  -0.121, 'W':  -0.884, 'Y' : -0.510}

    top_idp_noser = {'A':0.06, 'C' :  0.02, 'D' : 0.192, 'E' : 0.736,
        'F' :  -0.697, 'G' : 0.166, 'H':0.303, 'I' :  -0.486,
        'K' : 0.586, 'L' :  -0.326, 'M': -0.397, 'N' : 0.007,
        'P' : 0.987, 'Q' : 0.318, 'R' : 0.180, 'S':  0.,
        'T' : 0.059, 'V' :  -0.121, 'W':  -0.884, 'Y' : -0.510}
        
    top_idp_noserpro = {'A':0.06, 'C' :  0.02, 'D' : 0.192, 'E' : 0.736,
        'F' :  -0.697, 'G' : 0.166, 'H':0.303, 'I' :  -0.486,
        'K' : 0.586, 'L' :  -0.326, 'M': -0.397, 'N' : 0.007,
        'P' : 0., 'Q' : 0.318, 'R' : 0.180, 'S':  0.,
        'T' : 0.059, 'V' :  -0.121, 'W':  -0.884, 'Y' : -0.510}
        
    top_idp_noserlyspro = {'A':0.06, 'C' :  0.02, 'D' : 0.192, 'E' : 0.736,
        'F' :  -0.697, 'G' : 0.166, 'H':0.303, 'I' :  -0.486,
        'K' : 0., 'L' :  -0.326, 'M': -0.397, 'N' : 0.007,
        'P' : 0., 'Q' : 0.318, 'R' : 0.180, 'S':  0.,
        'T' : 0.059, 'V' :  -0.121, 'W':  -0.884, 'Y' : -0.510}
        
    dic_limits = {'freq_C':[0,0.03], 'freq_S':[0.03,0.1], 'length':[0,1000]}
    aas_sorted_topidp = ['W','F','Y','I','M','L','V','N','C','T','A','G','R','D','H','Q','S','K','E','P']

    codons2aa = {
        'ATA':'I', 'ATC':'I', 'ATT':'I', 'ATG':'M', 'ACA':'T', 'ACC':'T', 'ACG':'T', 'ACT':'T',
        'AAC':'N', 'AAT':'N', 'AAA':'K', 'AAG':'K', 'AGC':'S', 'AGT':'S', 'AGA':'R', 'AGG':'R',
        'CTA':'L', 'CTC':'L', 'CTG':'L', 'CTT':'L', 'CCA':'P', 'CCC':'P', 'CCG':'P', 'CCT':'P',
        'CAC':'H', 'CAT':'H', 'CAA':'Q', 'CAG':'Q', 'CGA':'R', 'CGC':'R', 'CGG':'R', 'CGT':'R',
        'GTA':'V', 'GTC':'V', 'GTG':'V', 'GTT':'V', 'GCA':'A', 'GCC':'A', 'GCG':'A', 'GCT':'A',
        'GAC':'D', 'GAT':'D', 'GAA':'E', 'GAG':'E', 'GGA':'G', 'GGC':'G', 'GGG':'G', 'GGT':'G',
        'TCA':'S', 'TCC':'S', 'TCG':'S', 'TCT':'S', 'TTC':'F', 'TTT':'F', 'TTA':'L', 'TTG':'L',
        'TAC':'Y', 'TAT':'Y', 'TAA':'_', 'TAG':'_', 'TGC':'C', 'TGT':'C', 'TGA':'_', 'TGG':'W'}
        
    aa2codons = {}
    aa2codons["ALL"] = []
    for c in codons2aa:
        aa2codons[codons2aa[c]] = aa2codons.get(codons2aa[c],[]) + [c]
        if c != "_":
            aa2codons["ALL"] += [c]
            

# In[2]:
    # these taxa should be excluded because their genetic code is different, so translation is wrong
    # open the three reference files
    data_dir="../data/"
    genomes_overview_file = data_dir + "overview.txt"
    genomes_euks_file = data_dir + "eukaryotes.txt"
    genomes_proks_file = data_dir + "prokaryotes.txt"
    df_overview = pd.read_csv(genomes_overview_file, sep="\t",low_memory="False")

    df_proks = pd.read_csv(genomes_proks_file, sep = "\t",low_memory="False")
    df_euks = pd.read_csv(genomes_euks_file, sep = "\t",low_memory="False")
    df_reference = pd.concat([df_euks, df_proks],sort=True)

    taxid2gc = df_reference.set_index("TaxID").to_dict()["GC%"]


    taxid2group = df_reference[["TaxID","Group"]].set_index("TaxID").to_dict()["Group"]
    group2kingdom = df_overview[["Group", "Kingdom"]].set_index("Group").to_dict()["Kingdom"]
    taxid2kingdom = {}

    for t in taxid2group:
        gr = taxid2group[t]
        taxid2kingdom[t] = group2kingdom[gr]
    
    taxid2name = df_reference[["#Organism/Name","TaxID"]].set_index("TaxID").to_dict()['#Organism/Name']
    name2taxid = df_reference[["#Organism/Name","TaxID"]].set_index("#Organism/Name").to_dict()['TaxID']
    mycotaxa = []
    for t in name2taxid:
        tax = t.split()[0]
        if tax in ["Mycoplasma","Spiroplasma","Ureaplasma","Mesoplasma"]:
            mycotaxa += [name2taxid[t]]
        
    minGC=20.
    maxGC=60.

    df = pd.read_csv("../data/df_uniprot_reference_proteomes_per_species-sum-GC-All.csv").dropna()
    df=df.loc[(df["GC_genomic"].astype(float) > minGC) & (df["GC_genomic"].astype(float)<maxGC) ]

    #df = pd.read_csv("../data/df_uniprot_reference_proteomes_per_species_dec2017.csv").dropna()

    good_taxa = set(df.taxon_id.unique()) - set(mycotaxa)

    # Select Bacteria and Eukaryota
    df = df.loc[(df.kingdom.isin(['Bacteria','Archaea','Eukaryota'])) & (df.taxon_id.isin(good_taxa))].convert_objects(convert_numeric=True)
    
    # We do calculate top-idp from AAfreq (with and without Ser)

    #idpS=df.apply(get_topidp, axis=1) This was just for checking
    #idpnoS=df.apply(get_topidp_noser, axis=1)
    df['topidp-S']=df.apply(get_topidp_noser, axis=1)
    df['topidp-SKP']=df.apply(get_topidp_noserlyspro, axis=1)
    df['topidp-SP']=df.apply(get_topidp_noserpro, axis=1)
    #print(idpS,idpnoS,df)
# In[30]:


    #kingdoms = df.kingdom.dropna().unique()

    
    propsA = ["freq_" + aa for aa in aas_sorted_topidp]
    propsB = ["freq_" + aa + "-shift" for aa in aas_sorted_topidp]
    
    #    kingdoms= ["Bacteria","Archaea","Eukaryota","Viruses"]
    kingdoms= ["Bacteria","Archaea","Eukaryota","Viruses"]
    phyla = df.phylum.dropna().unique()
    
    kingdom2color = {}
    for k, c in zip(kingdoms, ['#E20048', '#5064d0','#00B060',  '#FFA500']):
        kingdom2color[k] = c
        

    phylum2color = {}
    phylum2color_gc = {}

    for phylum in phyla:
        tdf = df.loc[df.phylum == phylum]
        kingdom = tdf.kingdom.iloc[0]
        col = kingdom2color[kingdom]
        phylum2color[phylum] = col
        
        gc = pd.np.mean(pd.np.array([float(f) for f in tdf.GC.replace("-",pd.np.nan).dropna()]))

        # color according to GC only
        # print (phylum,gc)
        if gc > 50:
            col = "darkred"
        elif gc > 45:
            col = "pink"
        elif gc > 40:
            col = "lightgreen"
        else:
            col = "darkgreen"
        cmap = cm.get_cmap('viridis')
        max=71
        min=34
        col=cmap( (gc-min)/(max-min))
        phylum2color_gc[phylum] = col


    
    data = {}

    props=propsA
    for phylum in phyla:

        tdf = df.loc[df.phylum == phylum]
        if len(tdf.length) > 10:
            d = []
            for prop in props:
                value = float(tdf[prop].mean())
                d += [value]
                
            #data[list(tdf.kingdom)[0] + " - " + phylum] = d
            data[phylum] = d


    data_dic = {}
    for s1 in data.keys():
        data_dic[s1] = {}
        for s2 in data.keys():
            #data_dic[s1][s2] = round(pd.np.corrcoef(data[s1], data[s2])[0, 1],3)
            data_dic[s1][s2] = 1/(1+distance.euclidean(data[s1],data[s2]))

    df_r = pd.DataFrame(data_dic)



    # plot a clustered heatmap of all-vs-all phyla

    colors_gc = [phylum2color_gc[p] for p in df_r.columns]
    for method in ["single","complete","average","weighted"]: # ,"centroid","ward"]:
        sns.set(font_scale=0.45)
        g = sns.clustermap(df_r,row_colors=colors_gc,cmap="Purples",method=method,metric='correlation')

        print (df_r)
        g.ax_row_colors.set_title("GC",fontsize=14)

        for lbl in g.ax_heatmap.yaxis.get_ticklabels():
            #lbl.set_color(phylum2color[lbl.get_text()])
            lbl.set_bbox(dict(facecolor=phylum2color[lbl.get_text()], alpha=1, edgecolor="white",
                            mutation_scale=2,mutation_aspect=0.2))
            
            
        # add a separate axis for the legend
        # left, bottom, width, height
        rect = 1.02,0.35,0.25,0.4 
        ax_legend = g.fig.add_axes(rect, label='axes1',facecolor="white")
        ax_legend.set_xticks([])
        ax_legend.set_yticks([])
        
        ptcs = []
        #for l,c in zip(["Bacteria","Archaea","Eukaryota","Viruses"],['#E20048', '#5064d0','#00B060',  '#FFA500']):
        for l,c in zip(["Bacteria","Archaea","Eukaryota"],['#E20048', '#5064d0','#00B060']):
        #for l,c in zip(["Bacteria","Eukaryota"],['#E20048', '#00B060']):
            ptcs += [mpatches.Patch(color=c, label=l)]
            
        ax_legend.legend(handles=ptcs,loc="upper left",fontsize=20)
        
        
        # add a separate axis for the GC viridis colorbar
        rect = 1.05,0.15,0.05,0.3 
        ax_cbar = g.fig.add_axes(rect, label='axes2',facecolor="white")
        ax_cbar.set_xticks([])
        ax_cbar.set_yticks([])
        
        ax_cbar.set_title("GC%",fontsize=14)

        '''
        import matplotlib as mpl
        mpl.rc('ytick', labelsize=20)
        mpl.rc('xtick', labelsize=20)
        cmap = mpl.cm.viridis
        norm = mpl.colors.Normalize(vmin=34, vmax=71)
        cb1 = mpl.colorbar.ColorbarBase(ax_cbar, cmap=cmap,
                                        norm=norm,
                                        orientation='vertical')
        '''
        ax_cbar.tick_params(axis='both', which='major', labelsize=10)
        
        plt.savefig(figures_dir+"/phyla_heatmap-"+method+".eps",bbox_inches="tight")
    
 
 
    # plot a clustered heatmap of aa frequency profiles for each phylum
    data_aa = []

    y_labels = []
    for phylum in phyla:
        tdf = df.loc[df.phylum == phylum]
        if len(tdf.length) > 10:
            
            d = []
            for prop in props:
                value = float(tdf[prop].mean())
                d += [value]

            #~ y_labels += [list(tdf.kingdom)[0] + " - " + phylum]
            y_labels += [phylum]
            data_aa += [d]

            
    sns.set()
    sns.set(font_scale=0.8)

    colors_gc = [phylum2color_gc[p] for p in y_labels]
    g = sns.clustermap(data_aa, col_cluster=False,yticklabels=y_labels, xticklabels=aas_sorted_topidp,cmap="Purples",annot=False, annot_kws={"size": 7},row_colors=colors_gc,method="ward") # ,metric='correlation')

    g.ax_row_colors.set_title("GC",fontsize=14)

    
    for lbl in g.ax_heatmap.yaxis.get_ticklabels():
        #lbl.set_color(phylum2color[lbl.get_text()])
        lbl.set_fontsize(6)
        lbl.set_bbox(dict(facecolor=phylum2color[lbl.get_text()], alpha=1, edgecolor="white",
                          mutation_scale=2,mutation_aspect=0.2))


    # add a separate axis for the legend
    # left, bottom, width, height
    rect = 1.02,0.35,0.25,0.4 
    ax_legend = g.fig.add_axes(rect, label='axes1',facecolor="white")
    ax_legend.set_xticks([])
    ax_legend.set_yticks([])

    ptcs = []
    #    for l,c in zip(["Bacteria","Archaea","Eukaryota","Viruses"],['#E20048', '#5064d0','#00B060',  '#FFA500']):
    for l,c in zip(["Bacteria","Archaea","Eukaryota"],['#E20048', '#5064d0','#00B060']):
        #for l,c in zip(["Bacteria","Eukaryota"],['#E20048','#00B060']):
        ptcs += [mpatches.Patch(color=c, label=l)]

    ax_legend.legend(handles=ptcs,loc="upper left",fontsize=20)


    # add a separate axis for the GC viridis colorbar
    rect = 1.05,0.15,0.05,0.3 
    ax_cbar = g.fig.add_axes(rect, label='axes2',facecolor="white")
    ax_cbar.set_xticks([])
    ax_cbar.set_yticks([])

    ax_cbar.set_title("GC%",fontsize=14)

    '''
    import matplotlib as mpl
    mpl.rc('ytick', labelsize=20)
    mpl.rc('xtick', labelsize=20)
    cmap = mpl.cm.viridis
    norm = mpl.colors.Normalize(vmin=34, vmax=71)
    cb1 = mpl.colorbar.ColorbarBase(ax_cbar, cmap=cmap,
                                    norm=norm,
                                    orientation='vertical')
    '''
    ax_cbar.tick_params(axis='both', which='major', labelsize=10)
    
    
    plt.savefig(figures_dir+"/phyla_aa_freq_heatmap.eps",bbox_inches="tight")



    plt.clf()
    plt.cla()
    plt.close()
    plt.gcf().clear()
    #exit()
    # This is just a copy of above
    props=propsB
    for phylum in phyla:

        tdf = df.loc[df.phylum == phylum]
        if len(tdf.length) > 10:
            d = []
            for prop in props:
                value = float(tdf[prop].mean())
                d += [value]
                
            #data[list(tdf.kingdom)[0] + " - " + phylum] = d
            data[phylum] = d


    data_dic = {}
    for s1 in data.keys():
        data_dic[s1] = {}
        for s2 in data.keys():
            #data_dic[s1][s2] = round(pd.np.corrcoef(data[s1], data[s2])[0, 1],3)
            data_dic[s1][s2] = 1/(1+distance.euclidean(data[s1],data[s2]))

    df_r = pd.DataFrame(data_dic)



    # plot a clustered heatmap of all-vs-all phyla

    colors_gc = [phylum2color_gc[p] for p in df_r.columns]
    for method in ["single","complete","average","weighted"]: # ,"centroid","ward"]:
        sns.set(font_scale=0.45)
        g = sns.clustermap(df_r,row_colors=colors_gc,cmap="Purples",method=method,metric='euclidean')

        g.ax_row_colors.set_title("GC",fontsize=14)

        for lbl in g.ax_heatmap.yaxis.get_ticklabels():
            #lbl.set_color(phylum2color[lbl.get_text()])
            lbl.set_bbox(dict(facecolor=phylum2color[lbl.get_text()], alpha=1, edgecolor="white",
                            mutation_scale=2,mutation_aspect=0.2))
            
            
        # add a separate axis for the legend
        # left, bottom, width, height
        rect = 1.02,0.35,0.25,0.4 
        ax_legend = g.fig.add_axes(rect, label='axes1',facecolor="white")
        ax_legend.set_xticks([])
        ax_legend.set_yticks([])
        
        ptcs = []
        for l,c in zip(["Bacteria","Archaea","Eukaryota"],['#E20048', '#5064d0','#00B060']):
            #for l,c in zip(["Bacteria","Eukaryota"],['#E20048', '#00B060'  ]):
            ptcs += [mpatches.Patch(color=c, label=l)]
            
        ax_legend.legend(handles=ptcs,loc="upper left",fontsize=20)
        
        
        # add a separate axis for the GC viridis colorbar
        #rect = 1.05,0.15,0.05,0.3 
        #ax_cbar = g.fig.add_axes(rect, label='axes2',facecolor="white")
        #ax_cbar.set_xticks([])
        #ax_cbar.set_yticks([])
        
        #ax_cbar.set_title("GC%",fontsize=14)
        
        '''
        import matplotlib as mpl
        mpl.rc('ytick', labelsize=20)
        mpl.rc('xtick', labelsize=20)
        cmap = mpl.cm.viridis
        norm = mpl.colors.Normalize(vmin=34, vmax=71)
        cb1 = mpl.colorbar.ColorbarBase(ax_cbar, cmap=cmap,
                                        norm=norm,
                                        orientation='vertical')
        '''
        ax_cbar.tick_params(axis='both', which='major', labelsize=10)
        
        
        plt.savefig(figures_dir+"/phyla_shift-heatmap-"+method+".eps",bbox_inches="tight")
    
 
 
    # plot a clustered heatmap of aa frequency profiles for each phylum
    data_aa = []

    y_labels = []
    for phylum in phyla:
        tdf = df.loc[df.phylum == phylum]
        if len(tdf.length) > 10:
            
            d = []
            for prop in props:
                value = float(tdf[prop].mean())
                d += [value]

            #~ y_labels += [list(tdf.kingdom)[0] + " - " + phylum]
            y_labels += [phylum]
            data_aa += [d]

            
    sns.set()
    sns.set(font_scale=0.8)

    for distance in ["euclidean"]: #,"hamming",'correlation','jaccard']:
        for method in ["weighted"]:# "single","complete","average","weighted"]:    
            #colors_gc = [phylum2color_gc[p] for p in y_labels]
            g = sns.clustermap(data_aa, col_cluster=True,yticklabels=y_labels, xticklabels=aas_sorted_topidp,cmap="bwr",annot=False, annot_kws={"size": 7},method=method ,metric=distance)
            
            #g.ax_row_colors.set_title("GC",fontsize=14)
        
        
            for lbl in g.ax_heatmap.yaxis.get_ticklabels():
                lbl.set_color(phylum2color[lbl.get_text()])
                lbl.set_fontsize(6)
                #lbl.set_bbox(dict(facecolor=phylum2color[lbl.get_text()], alpha=1, edgecolor="white",
                #            mutation_scale=2,mutation_aspect=0.2))


            # add a separate axis for the legend
            # left, bottom, width, height
            rect = 1.02,0.35,0.25,0.4 
            ax_legend = g.fig.add_axes(rect, label='axes1',facecolor="white")
            ax_legend.set_xticks([])
            ax_legend.set_yticks([])
        
            ptcs = []
            for l,c in zip(["Bacteria",'Archaea',"Eukaryota"],['#E20048', '#5064d0','#00B060'  ]):
                #for l,c in zip(["Bacteria","Eukaryota"],['#E20048','#00B060']):
                ptcs += [mpatches.Patch(color=c, label=l)]
            
            ax_legend.legend(handles=ptcs,loc="upper left",fontsize=20)


            # add a separate axis for the GC viridis colorbar
            #rect = 1.05,0.15,0.05,0.3 
            #ax_cbar = g.fig.add_axes(rect, label='axes2',facecolor="white")
            #ax_cbar.set_xticks([])
            #ax_cbar.set_yticks([])
        
            #ax_cbar.set_title("GC%",fontsize=14)
        
            '''
            import matplotlib as mpl
            mpl.rc('ytick', labelsize=20)
            mpl.rc('xtick', labelsize=20)
            cmap = mpl.cm.viridis
            norm = mpl.colors.Normalize(vmin=34, vmax=71)
            cb1 = mpl.colorbar.ColorbarBase(ax_cbar, cmap=cmap,
            norm=norm,
            orientation='vertical')
            '''
            ax_cbar.tick_params(axis='both', which='major', labelsize=10)
    
    
            plt.savefig(figures_dir+"/phyla_aa_shift_"+method+"_"+distance+"_heatmap.eps",bbox_inches="tight")
            plt.clf()
            plt.cla()
            plt.close()
            plt.gcf().clear()
        #exit()
