#!/usr/bin/env python
import pandas as pd
import os
from Bio.Seq import Seq
#import matplotlib as mpl
from matplotlib.text import TextPath
#from matplotlib.patches import PathPatch
from matplotlib.font_manager import FontProperties
#import matplotlib.pyplot as plt
#import gact

def letterAt(letter, x, y, yscale=1, ax=None):
    text = LETTERS[letter]#

    t = mpl.transforms.Affine2D().scale(1*globscale, yscale*globscale) + \
        mpl.transforms.Affine2D().translate(x,y) + ax.transData
    p = PathPatch(text, lw=0, fc=COLOR_SCHEME[letter],  transform=t)
    if ax != None:
        ax.add_artist(p)
    return p


if __name__ == '__main__':

    fp = FontProperties(family="Arial", weight="bold") 
    NA_LETTERS = { "T" : TextPath((-0.305, 0), "T", size=1, prop=fp),
                "G" : TextPath((-0.384, 0), "G", size=1, prop=fp),
                "A" : TextPath((-0.35, 0), "A", size=1, prop=fp),
                "C" : TextPath((-0.366, 0), "C", size=1, prop=fp) }
    NA_COLOR_SCHEME = {'G': 'orange', 
                    'A': 'red', 
                    'C': 'blue', 
                    'T': 'darkgreen'}

    AA_LETTERS = { "-" : TextPath((-0.35, 0), "-", size=1, prop=fp),
                "A" : TextPath((-0.35, 0), "A", size=1, prop=fp),
                "C" : TextPath((-0.35, 0), "C", size=1, prop=fp),
                "D" : TextPath((-0.35, 0), "D", size=1, prop=fp),
                "E" : TextPath((-0.35, 0), "E", size=1, prop=fp),
                "F" : TextPath((-0.35, 0), "F", size=1, prop=fp),
                "G" : TextPath((-0.35, 0), "G", size=1, prop=fp),
                "H" : TextPath((-0.35, 0), "H", size=1, prop=fp),
                "I" : TextPath((-0.35, 0), "I", size=1, prop=fp),
                "K" : TextPath((-0.35, 0), "K", size=1, prop=fp),
                "L" : TextPath((-0.35, 0), "L", size=1, prop=fp),
                "M" : TextPath((-0.35, 0), "O", size=1, prop=fp),
                "N" : TextPath((-0.35, 0), "N", size=1, prop=fp),
                "P" : TextPath((-0.35, 0), "P", size=1, prop=fp),
                "Q" : TextPath((-0.35, 0), "Q", size=1, prop=fp),
                "R" : TextPath((-0.35, 0), "R", size=1, prop=fp),
                "S" : TextPath((-0.35, 0), "S", size=1, prop=fp),
                "T" : TextPath((-0.35, 0), "T", size=1, prop=fp),
                "V" : TextPath((-0.35, 0), "V", size=1, prop=fp),
                "W" : TextPath((-0.35, 0), "W", size=1, prop=fp),
                "Y" : TextPath((-0.35, 0), "Y", size=1, prop=fp) }

    AA_COLOR_SCHEME = {'-': 'black', 
                    'A': 'blue', 
                    'C': 'blue', 
                    'D': 'blue', 
                    'E': 'blue', 
                    'F': 'blue', 
                    'G': 'blue', 
                    'H': 'blue', 
                    'I': 'blue', 
                    'K': 'blue', 
                    'L': 'blue', 
                    'M': 'blue', 
                    'N': 'blue', 
                    'P': 'blue', 
                    'Q': 'blue', 
                    'R': 'blue', 
                    'S': 'red', 
                    'T': 'blue', 
                    'V': 'blue', 
                    'W': 'blue', 
                    'Y': 'blue'}



        # We will use matplotlib instead
        # See: https://stackoverflow.com/questions/42615527/sequence-logos-in-matplotlib-aligning-xticks
        fig, ax = plt.subplots(figsize=(10,3))
        x = 1
        maxi = 0
        for scores in bac_freq:
            y = 0
            for base, score in scores:
                gact.letterAt(base, x,y, score, ax)
                y += score
            x += 1
            maxi = max(maxi, y)

        plt.xticks(range(1,x))
        plt.xlim((0, x)) 
        plt.ylim((0, maxi)) 
        plt.tight_layout()      
        plt.show()
        
