#!/bin/bash -x


# We use weblogo (installed by pip)
# Instructions: http://weblogo.threeplusone.com/manual.html


j=$1



for i in ../data/pfam/$j*bac*.fa
do
    k=`basename $i .fa`
    if [ ! -s /dev/null/$k.eps ]
    then
	weblogo -n 100 -s large --scale-width YES --title "Bacterial"  --errorbars NO --resolution 600 --color black ACDEFGHKLMNQRTVWY others --color red S serine --color green P proline --color blue I isoleucine  --format eps -f  $i  -o ../figures/$k.eps
    fi
done

for i in ../data/pfam/$j*arch*.fa
do
    k=`basename $i .fa`
    if [ ! -s /dev/null/$k.eps ]
    then
	weblogo -n 100 -s large  --scale-width YES --title "Archaea"  --errorbars NO --resolution 600 --color black ACDEFGHKLMNQRTVWY others --color red S serine --color green P proline --color blue I isoleucine  --format eps -f  $i  -o ../figures/$k.eps
    fi
done

for i in ../data/pfam/$j*vir*.fa
do
    k=`basename $i .fa`
    if [ ! -s /dev/null/$k.eps ]
    then
	weblogo -n 100 -s large  --scale-width YES --title "Viral"  --errorbars NO --resolution 600 --color black ACDEFGHKLMNQRTVWY others --color red S serine --color green P proline --color blue I isoleucine  --format eps -f  $i  -o ../figures/$k.eps
    fi
done

for i in ../data/pfam/$j*euk*.fa
do
    k=`basename $i .fa`
    if [ ! -s /dev/null/$k.eps ]
    then
	weblogo -n 100 -s large  --scale-width YES --title "Eukaryotic"   --errorbars NO --resolution 600 --color black ACDEFGHKLMNQRTVWY others --color red S serine --color green P proline --color blue I  isoleucine --format eps -f  $i  -o ../figures/$k.eps
    fi
done


for i in ../data/pfam/$j*.ss
do
    k=`basename $i -full.ss`
    if [ ! -s /dev/null/$k-ss.eps ]
    then
	weblogo -n 100  --title "Secondary structure" --errorbars NO --resolution 600 --alphabet HIGEBSTC --color red HIG Helix --color green EB Sheet --color black STC Loop   --format eps -s large   --scale-width YES -f  $i -o ../figures/$k-ss.eps
    fi
done


    # Other parameters -n (max logos per line)


